#
# Sun RPC is a product of Sun Microsystems, Inc. and is provided for
# unrestricted use provided that this legend is included on all tape
# media and as a part of the software program in whole or part.  Users
# may copy or modify Sun RPC without charge, but are not authorized
# to license or distribute it to anyone else except as part of a product or
# program developed by the user.
#
# SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
# WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
# PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
#
# Sun RPC is provided with no support and without any obligation on the
# part of Sun Microsystems, Inc. to assist in its use, correction,
# modification or enhancement.
#
# SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
# INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
# OR ANY PART THEREOF.
#
# In no event will Sun Microsystems, Inc. be liable for any lost revenue
# or profits or other special, indirect and consequential damages, even if
# Sun has been advised of the possibility of such damages.
#
# Sun Microsystems, Inc.
# 2550 Garcia Avenue
# Mountain View, California  94043
#
#
# Makefile for rpcbind
#

LINKLIBS = -lnsl
DESTDIR = $(ROOT)/usr/sbin
INC = $(ROOT)/usr/include
LINT = lint
DEBUG= -DBIND_DEBUG
CPPFLAGS= -DPORTMAP -I$(INC)
CFLAGS = -O $(CPPFLAGS)
INS = install

STRIP = strip

SIZE = size

MAINS = rpcbind

OBJS = rpcbind.o rpcb_svc.o pmap_svc.o check_bound.o stricmp.o 

HDRS = rpcbind.h

SRCS = $(OBJS:.o=.c)

all:	$(OBJS)
	$(CC) $(CFLAGS) -o $(MAINS) $(OBJS) $(LINKLIBS) $(SHLIBS) 

$(OBJS): $(HDRS)

install: all
	$(INS) -f $(DESTDIR) -m 0555 -u bin -g bin $(MAINS)

size: all
	$(SIZE) $(MAINS)

strip: all
	$(STRIP) $(MAINS)

lint:
	$(LINT) $(CFLAGS) $(SRCS) 

clean:
	rm -f $(OBJS)

clobber: clean
	rm -f $(MAINS)
